<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>userDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN CHI TIẾT NGƯỜI DÙNG</h3>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-user-id">Nhập Id của user <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-user-id" placeholder="Nhập id user ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onBtnLayThongTinClick()">Lấy thông tin</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Một số id user đúng để test: <span class="text-danger">172728, 172729, 172730,
                    172731, 172732, 172733, 172745</span></div>
        </div>

        <hr>

        <div class="row form-group mt-4">
            <label class="col-form-label col-sm-4" for="input-firstname">First name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-firstname" placeholder="First name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-lastname">Last name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-lastname" placeholder="Last name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-subject">Subject <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input type="text" id="input-subject" placeholder="Subject" class="form-control">
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-country">Country</label>
            <div class="col-sm-8">
                <select id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="AUS">Australia</option>
                    <option value="USA">USA</option>
                    <option value="CAN">Canada</option>
                    <option value="JP">Japan</option>
                </select>
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-customer-type">Customer Type</label>
            <div class="col-sm-8">
                <select id="select-customer-type" class="form-control">
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                    <option value="Standard">Standard</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-register-status">Register Status</label>
            <div class="col-sm-8">
                <select id="select-register-status" class="form-control">
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                    <option value="New">New</option>
                </select>
            </div>
        </div>
        <div class="row form-group" style="justify-content: flex-end;">
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onBtnCapNhatUserClick()" >Cập nhật user</button>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // trạng thái của server trả về, 200 = tìm thấy thành công!
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //Khai bao doi tuong de chua du lieu tren form
    var gUserObj = {
            id: "",
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customertype: "",
            registerstatus: "",
        }

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    function onBtnLayThongTinClick() {
        //B1: Thu Thap Du Lieu
        thuThapDuLieu(gUserObj);
        //B2: Validate du lieu
        var vDuLieuHople = kiemTraDuLieu(gUserObj);
        if (vDuLieuHople) {
            var vXmlHttp = new XMLHttpRequest();
            //B3: goi api de kiem tra 
            goiAPIDeCheckUser(gUserObj, vXmlHttp);
            //B4: hien thi thong tin 
            hienThiThongTinUser(vXmlHttp);
        }
    }

    function onBtnCapNhatUserClick() {
        //B1: Thu Thap Du Lieu
        thuThapDuLieu(gUserObj);
        //B2: Validate du lieu
        var vDuLieuHople = kiemTraDuLieuCapNhat(gUserObj);
        if (vDuLieuHople) {
            var vXmlHttp = new XMLHttpRequest();
            //B3: goi api de kiem tra 
            goiAPIDeCapNhatUser(gUserObj, vXmlHttp);
            //B4: hien thi thong tin 
            TrangThaiCapNhat(vXmlHttp);
        }
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserObj) {
        var vIdUserInputElement = document.getElementById("input-user-id");
        paramUserObj.id = vIdUserInputElement.value.trim();
        var vFirstnameInputElement = document.getElementById("input-firstname");
        paramUserObj.firstname = vFirstnameInputElement.value.trim();
        var vLastnameInputElement = document.getElementById("input-lastname");
        paramUserObj.lastname = vLastnameInputElement.value.trim();
        var vSubjectInputElement = document.getElementById("input-subject");
        paramUserObj.subject = vSubjectInputElement.value.trim();
        var vCountrySelectElement = document.getElementById("select-country");
        paramUserObj.country = vCountrySelectElement.value;
        var vCustomerTypeSelectElement = document.getElementById("select-customer-type");
        paramUserObj.customerType = vCustomerTypeSelectElement.value;
        var vRegisterStatusSelectElement = document.getElementById("select-register-status");
        paramUserObj.registerStatus = vRegisterStatusSelectElement.value;
    }

    function kiemTraDuLieu(paramUserObj) {
        if (paramUserObj.id == "") {
            alert("Bạn chưa nhập user id!");
            return false;
        }
        if (isNaN(paramUserObj.id)) {
            alert("User ID phải là số!");
            return false;
        }
        return true;
    }

    function goiAPIDeCheckUser(paramUserObj, paramXmlHttpObj) {
        paramXmlHttpObj.open("GET", "http://203.171.20.210:8080/crud-api/users/" + paramUserObj.id, false);
        paramXmlHttpObj.send();
        console.log(paramXmlHttpObj.responseText);
    }

    function hienThiThongTinUser(paramXmlHttpObj) {
        var vStatusCode = paramXmlHttpObj.status;
        // nếu trạng thái trả về thành công!
        if (vStatusCode == gREQUEST_STATUS_OK) {
            // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
            var bUserResponse = JSON.parse(paramXmlHttpObj.responseText);

            var vFirstnameInputElement = document.getElementById("input-firstname");
            var vLastnameInputElement = document.getElementById("input-lastname");
            var vSubjectInputElement = document.getElementById("input-subject");
            var vCountrySelectElement = document.getElementById("select-country");
            var vCustomerTypeSelectElement = document.getElementById("select-customer-type");
            var vRegisterStatusSelectElement = document.getElementById("select-register-status");

            vFirstnameInputElement.value = bUserResponse.firstname;
            vLastnameInputElement.value = bUserResponse.lastname;
            vSubjectInputElement.value = bUserResponse.subject;
            vCountrySelectElement.value = bUserResponse.country;
            vCustomerTypeSelectElement.value = bUserResponse.customerType;
            vRegisterStatusSelectElement.value = bUserResponse.registerStatus;
        }
        else {
            alert("Không tồn tại User với id đã nhập");
        }
    }

    function kiemTraDuLieuCapNhat(paramUserObj) {
        if (paramUserObj.firstname == "") {
            alert("Bạn chưa nhập firstname!");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Bạn chưa nhập lastname!");
            return false;
        }
        if (paramUserObj.subject == "") {
            alert("Bạn chưa nhập subject!");
            return false;
        }
        return true;
    }

    function goiAPIDeCapNhatUser(paramUserObj, paramXmlHttpObj) {
        paramXmlHttpObj.open("PUT", "http://203.171.20.210:8080/crud-api/users/" + paramUserObj.id, true);
        paramXmlHttpObj.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttpObj.send(JSON.stringify(paramUserObj));
    }

    function TrangThaiCapNhat (paramXmlHttpObj) {
        paramXmlHttpObj.onreadystatechange = function() {
            if (paramXmlHttpObj.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && paramXmlHttpObj.status == gREQUEST_STATUS_OK) {
                console.log(" update" + paramXmlHttpObj.responseText);
                alert("Cập nhật thành công!");
            }
        }
    }
</script>

</html>